import type Collection from "@arcgis/core/core/Collection";
import type Layer from "@arcgis/core/layers/Layer";
import type StreamLayer from "@arcgis/core/layers/StreamLayer";
import type Field from "@arcgis/core/layers/support/Field";
import type PortalItem from "@arcgis/core/portal/PortalItem";
import type { RendererUnion } from "@arcgis/core/renderers/types.js";
import type { FeatureSettings } from "../data/FeatureSettings.js";
import type { QuerySourceCapabilities } from "../data/QuerySourceCapabilities.js";
import type { Schema } from "../data/Schema.js";
import type { StreamLayerJson } from "../json/StreamLayerJson.js";
import type { PropertyDefs } from "../support/Serializable.js";
import type { LayerExtensionProperties, LayerProperties, LayerExtensionSchemaPropertyBinding } from "./_LayerExtension.js";
import { LayerExtension, LayerExtensionSchema } from "./_LayerExtension.js";
/**
 * Properties that can be passed into the constructor for
 * {@link StreamLayerExtension}.
 */
export interface StreamLayerExtensionProperties extends LayerExtensionProperties {
    /**
     * The Esri StreamLayer object being extended.
     */
    layer?: StreamLayer | (StreamLayerJson & LayerProperties);
}
/**
 * Extends the capabilities of an Esri `StreamLayer` object.
 */
export declare class StreamLayerExtension extends LayerExtension<StreamLayerExtensionProperties> {
    get layer(): StreamLayer;
    get hasFeatures(): boolean;
    get renderer(): RendererUnion;
    get canChangeLabels(): boolean;
    get canChangeRenderer(): boolean;
    get canChangeDefinitionExpression(): boolean;
    /**
     * @inheritDoc
     */
    protected _capabilities(): QuerySourceCapabilities;
    protected _getSerializableProperties(): PropertyDefs<StreamLayerExtensionProperties>;
    protected _createSchema(): Schema;
    /**
     * @inheritDoc
     */
    protected _isSupportedLayer(layer: Layer): boolean;
    protected _createFeatureSettings(): FeatureSettings;
    protected _applyPortalItemProperties(portalItem: PortalItem): Promise<void>;
}
/**
 * An implementation of Schema that directly mirrors the equivalent properties
 * on StreamLayer.
 */
export declare class StreamLayerSchema extends LayerExtensionSchema {
    private readonly _fieldCollection;
    constructor(layerExtension: StreamLayerExtension);
    destroy(): void;
    get _fields(): Collection<Field>;
    /**
     * Creates the backing collection for fields.
     */
    protected _createFieldCollection(): Collection<Field>;
    protected _getPropertyBindings(): Partial<Record<keyof this, LayerExtensionSchemaPropertyBinding>>;
}
